

function [cmap_gen]=cmap_generator(clr_level,clr_level_val,clr_map_grid)


clr_level_num=length(clr_level_val);
clr_min=clr_level_val{1};
clr_max=clr_level_val{end};

clr_level_grid=linspace(clr_min,clr_max,clr_map_grid);
clr_level_ind=zeros(1,clr_level_num);
cmap_gen=zeros(clr_map_grid,3);

for ti_temp=1:1:clr_level_num
    [Y,clr_level_ind(ti_temp)]=min(abs(clr_level_val{ti_temp}-clr_level_grid));
end

for ti_temp=1:1:(clr_level_num-1)
    ind_st=clr_level_ind(ti_temp);
    ind_ed=clr_level_ind(ti_temp+1);
    for ind_temp=ind_st:1:ind_ed
        cmap_gen(ind_temp,:)=clr_level{ti_temp}+(clr_level{ti_temp+1}-clr_level{ti_temp}).*(ind_temp-ind_st)./(ind_ed-ind_st);
    end
end
