
clear all;
close all;

mkdir('./Post_Proc_data/');

post_proc_prefer_type_arr=[1,2,3,4,5,6,17,18,19,20,21];

for ti_post_type=1:1:length(post_proc_prefer_type_arr)

    save('ti_post_type','ti_post_type','post_proc_prefer_type_arr');

    prefer_type=post_proc_prefer_type_arr(ti_post_type);
    data_folder_name=['../Data_Generation/SHU_Dynamic_Type_',num2str(prefer_type,'%03i')];

    %%
    NN=500;
    km_ROI_max=0.5;
    km_ROI_min=0.05;
    NN_pre=1;
    NN_post=0;

    rng_arr_max=100;

    for ti_EVOL=1:1:NN
        weight_degree_training_arr{ti_EVOL}=zeros(ti_EVOL*rng_arr_max,1);    %% (Entire Degrees, 1)
        weight_degree_SS_k_arr{ti_EVOL}=zeros(ti_EVOL*rng_arr_max,1);    %% (Entire Degrees, 1)
        weight_degree_SS_k_inner_arr{ti_EVOL}=zeros(ti_EVOL*rng_arr_max,1);    %% (Entire Degrees, 1)
        weight_degree_SS_k_outer_arr{ti_EVOL}=zeros(ti_EVOL*rng_arr_max,1);    %% (Entire Degrees, 1)
    end

    SS_k_evol_training_arr=zeros(rng_arr_max,NN);
    SS_k_evol_arr=zeros(rng_arr_max,NN);
    SS_k_evol_inner_arr=zeros(rng_arr_max,NN);
    SS_k_evol_outer_arr=zeros(rng_arr_max,NN);

    rr_vec_arr=zeros(NN*rng_arr_max,2);

    SS_k_2D_set=cell(rng_arr_max,1);
    rr_vec_set=cell(rng_arr_max,1);

    for ti_rng=1:1:rng_arr_max
        rng_param=ti_rng;
        data_file_name=[data_folder_name,'/Data/Pref_',num2str(prefer_type,'%03i'),'_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i'),'_rng_',num2str(rng_param,'%03i')]
        load(data_file_name);

        for ti_EVOL=1:1:NN
            if mod(ti_EVOL,10)==0
                ['Process = ',num2str((ti_EVOL-1)./(NN-1)*100),'%']
            end
            weight_degree_training_arr{ti_EVOL}(((ti_rng-1).*ti_EVOL+1):1:(ti_rng.*ti_EVOL),1)=sum(weightpq(1:1:ti_EVOL,1:1:ti_EVOL),1);
            weight_degree_SS_k_arr{ti_EVOL}(((ti_rng-1).*ti_EVOL+1):1:(ti_rng.*ti_EVOL),1)=sum(weightpq_SS_k(1:1:ti_EVOL,1:1:ti_EVOL),1);
            weight_degree_SS_k_inner_arr{ti_EVOL}(((ti_rng-1).*ti_EVOL+1):1:(ti_rng.*ti_EVOL),1)=sum(weightpq_SS_k_inner(1:1:ti_EVOL,1:1:ti_EVOL),1);
            weight_degree_SS_k_outer_arr{ti_EVOL}(((ti_rng-1).*ti_EVOL+1):1:(ti_rng.*ti_EVOL),1)=sum(weightpq_SS_k_outer(1:1:ti_EVOL,1:1:ti_EVOL),1);
            if ti_EVOL==1
                kk_range_set_min(:,1)=kk_ROI_min.*cos(theta_cand_k);
                kk_range_set_min(:,2)=kk_ROI_min.*sin(theta_cand_k);
                kk_range_set_max(:,1)=kk_ROI_max.*cos(theta_cand_k);
                kk_range_set_max(:,2)=kk_ROI_max.*sin(theta_cand_k);
                k_1D_abs=sqrt((kk_range_set(:,1).^2)+(kk_range_set(:,2).^2));
                k_1D_theta=atan(kk_range_set(:,2)./kk_range_set(:,1));
                [k_1D_abs_sort,abs_sort_ind]=sort(k_1D_abs,'ascend');
                [k_1D_theta_sort,theta_sort_ind]=sort(k_1D_theta,'ascend');

                SS_k_final_arr_1D=zeros(kk_axis_num(1).*kk_axis_num(2),rng_arr_max);
                SS_k_final_arr_abs_sort=zeros(kk_axis_num(1).*kk_axis_num(2),rng_arr_max);
                SS_k_final_arr_theta_sort=zeros(kk_axis_num(1).*kk_axis_num(2),rng_arr_max);
            end
        end

        SS_k_evol_training_arr(ti_rng,:)=SS_k_evol_training;
        SS_k_evol_arr(ti_rng,:)=SS_k_evol;
        SS_k_evol_inner_arr(ti_rng,:)=SS_k_evol_inner;
        SS_k_evol_outer_arr(ti_rng,:)=SS_k_evol_outer;

        SS_k_final_arr_1D(:,ti_rng)=reshape(SS_k_2D,kk_axis_num(1).*kk_axis_num(2),1);
        SS_k_final_arr_abs_sort(:,ti_rng)=SS_k_final_arr_1D(abs_sort_ind,ti_rng);
        SS_k_final_arr_theta_sort(:,ti_rng)=SS_k_final_arr_1D(theta_sort_ind,ti_rng);

        rr_vec_arr(((ti_rng-1).*NN+1):1:(ti_rng.*NN),:)=rr_vec;

        SS_k_2D_set{ti_rng}=SS_k_2D;
        rr_vec_set{ti_rng}=rr_vec;

    end

    save_file_name=['./Post_Proc_data/Post_Data_',num2str(prefer_type,'%03i'),'_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i')]
    save(save_file_name,'-v7.3');

    clear all;
    load('ti_post_type.mat');

end

    


