
clear all;
NN=500;
km_ROI_max=0.5;
km_ROI_min=0.05;
NN_pre=1;
NN_post=0;

rng_arr_max=100;
prefer_type_arr=[1,2,3,4,5,6,17,18,19,20,21];

for ti_post_type_hist=1:1:length(prefer_type_arr)  
    prefer_type=prefer_type_arr(ti_post_type_hist);
    load_file_name=['./Hist_Data/Hist_Data_',num2str(prefer_type,'%03i'),'_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i')]
    load(load_file_name);
    load('post_preference_ele.mat');
    SS_k_evol_arr_set(:,:,ti_post_type_hist)=SS_k_evol_arr;
    SS_k_evol_inner_arr_set(:,:,ti_post_type_hist)=SS_k_evol_inner_arr;
    SS_k_evol_outer_arr_set(:,:,ti_post_type_hist)=SS_k_evol_outer_arr;
end
save_file_name=['./Hist_Data/Hist_Set_Data_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i')]    
save(save_file_name);
    